/* poll()-based monitor class.
 *
 * PegSoft sockets library (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MY_POLL_H
#define MY_POLL_H

/*************************************************************************/
 
#if HAVE_POLL_H
# include <poll.h>
#endif

#include <vector>

#include "sockets/monitor.h"

/*************************************************************************/

namespace sockets
{

/*************************************************************************/

class Poll : public Monitor
{
	public:
		/// Constructor.
		Poll(size_t hint);
	protected:
		virtual void do_events();
		virtual bool add(Socket *s, int fd, unsigned int events);
		virtual bool update(Socket *s, int fd, unsigned int events);
		virtual void remove(Socket *s, int fd);
	private:
		typedef std::vector<int> idx_list;
		typedef std::vector<struct pollfd> fds_list;
		
		/// Master FD list
		fds_list m_fds;
		/// FD list to pass to poll().
		fds_list m_pfds;
};

/*************************************************************************/

} /* namespace sockets */

/*************************************************************************/

#endif /* MY_POLL_H */
