/* A simple strcasecmp() implementation.
 *
 * PegSoft compatibility library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include "system/headers.h"
#include "system/compat.h"

/*************************************************************************/

int compat_strcasecmp(char const *s1, char const *s2)
{
	unsigned char c1, c2;
	
	do {
		if ((c1 = (unsigned char)tolower(*s1)) < (c2 = (unsigned char)tolower(*s2++)))
			return -1;
		else if (c1 > c2)
			return 1;
	} while (*s1++);
	
	/* If it falls there then the strings are identical */
	return 0;
}

/*************************************************************************/
