/* Essential tools.
 *
 * PegSoft compatibility library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

/** \file system/headers.h
  * \brief Header file including generic system headers.
  *
  * This header file must be included before any other program header. It
  * includes the most used system headers and system/compat.h. */

#ifndef SYSTEM_HEADERS_H
#define SYSTEM_HEADERS_H

/*************************************************************************/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#ifndef _GNU_SOURCE
# define _GNU_SOURCE	1
#endif

#if defined(__cplusplus)
# include <cstdio>
# include <cstdlib>
# include <cstddef>
# include <cstdarg>
# include <cstring>
# include <cctype>
# include <cerrno>
# include <climits>
#else
# include <stdio.h>
# if STDC_HEADERS
#  include <stdlib.h>
#  include <stddef.h>
#  include <stdarg.h>
# else
#  if HAVE_STDLIB_H
#   include <stdlib.h>
#  endif
#  if HAVE_STDDEF_H
#   include <stddef.h>
#  endif
#  if HAVE_STDARG_H
#   include <stdarg.h>
#  endif
# endif
# if HAVE_STRING_H
#  include <string.h>
# endif
# if HAVE_CTYPE_H
#  include <ctype.h>
# endif
# if HAVE_ERRNO_H
#  include <errno.h>
# endif
# if HAVE_LIMITS_H
#  include <limits.h>
# endif
#endif

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# if defined(__cplusplus)
#  include <ctime>
# else
#  include <time.h>
# endif
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  if defined(__cplusplus)
#   include <ctime>
#  else
#   include <time.h>
#  endif
# endif
#endif

#if HAVE_INTTYPES_H
# include <inttypes.h>
#else
# if HAVE_STDINT_H
#  include <stdint.h>
# endif
#endif

#if HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#if !STDC_HEADERS && HAVE_MEMORY_H
# include <memory.h>
#endif
#if HAVE_STRINGS_H
# include <strings.h>
#endif

#if HAVE_UNISTD_H
# include <unistd.h>
#endif

/*************************************************************************/

#include <system/compat.h>

/*************************************************************************/

#endif /* SYSTEM_HEADERS_H */
