/* Password interface.
 *
 * MD5 module (c) 2006 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef PASSWORD_H
#define PASSWORD_H

/*************************************************************************/

#include <password/password.h>

/*************************************************************************/
	
namespace md5 
{

/*************************************************************************/

/// Password interface.

class Encrypter : public password::Encrypter
{
	public:
		/// Encrypted password size.
		static size_t const encpass_size = 32;
		
		/// Implements Encrypter::module().
		virtual modules::Module *module();
		
		/// Implements Encrypter::length().
		virtual size_t length() const { return encpass_size; }
		
		/// Implements Encrypter::encrypt(char const *, char *, size_t).
		virtual bool encrypt(char const *pass, char *buf,
				size_t bufsize);
		
		/// Implements Encrypter::encrypt(char *, size_t).
		virtual bool encrypt(char *buf, size_t size);
		
		/// Implements Encrypter::check().
		virtual bool check(char const *plain, char const *pass);
};

/*************************************************************************/

} /* namespace md5 */

/*************************************************************************/

#endif /* PASSWORD_H */
