/* MySQL client module.
 *
 * MySQL client module (c) 2006 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <modules/module.h>

/*************************************************************************/

namespace modules { class Core; }

/*************************************************************************/

namespace mysql_cli 
{

/*************************************************************************/

/// MySQLCli module version
static int const mysql_cli_version = 0x01000000;

/// The mysql_cli module class
class MySQLCli : public modules::Module
{
	public:
		/// Constructor.
		MySQLCli(modules::Core &core);
		
		/// Implements Module::version().
		virtual int version() const { return mysql_cli_version; }
		
		/// Returns the core module.
		modules::Core &core() { return *m_core; }
	private:
		modules::Core *m_core;
};

/*************************************************************************/

} /* namespace mysql_cli */

/*************************************************************************/

#endif /* MODULE_H */
