/* XML import/export.
 *
 * MySQL database module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef XML_H
#define XML_H

/*************************************************************************/

#include <databases/xml.h>

/*************************************************************************/
	
namespace mysql 
{

/*************************************************************************/

class XMLExport : public databases::XMLExport
{
	public:
		/// Implements databases::XMLExport::export_data().
		virtual bool export_data(std::string const &dir,
				databases::XMLIndex &index, std::string const &database = "");
};

/*************************************************************************/

class XMLImport : public databases::XMLImport
{
	public:
		/// Implements databases::XMLImport::import_data().
		virtual bool import_data(std::string const &dir,
				std::string const &database);
};

/*************************************************************************/

} /* namespace mysql */

/*************************************************************************/

#endif /* XML_H */
