/* Transport interface.
 *
 * Sendmail mail transport module (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <system/headers.h>

#include <mail/mail.h>
#include <mail/transport.h>

#include "conf.h"
#include "decl.h"
#include "module.h"
#include "transport.h"

using namespace std;

/*************************************************************************/

namespace sendmail
{

/*************************************************************************/

bool Transport::deliver(mail::Mail const &mail, bool *temp)
{
	errno = 0;
	FILE *pipe = popen(me->cd().command, "w");
	
	if (!pipe)
	{
		if (errno)
			errorf("Open error: %s", strerror(errno));
		else
			errorf("Out of memory");
		
		*temp = true;
		return false;
	}
	
	if (fputs(mail.data().c_str(), pipe) == EOF ||
			fputs(".\n", pipe) == EOF)
	{
		errorf("Write error: %s",  strerror(errno));
		pclose(pipe);
		
		*temp = true;
		return false;
	}
	
	pclose(pipe);
	return true;
}

/*************************************************************************/

} /* namespace sendmail */

/*************************************************************************/
