/* Configuration.
 *
 * Twilight database module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CONF_H
#define CONF_H

/*************************************************************************/

#include <conf/directives.h>
#include <conf/quick.h>

/*************************************************************************/
	
namespace twilight 
{

/*************************************************************************/

class Directives : public conf::DirectivesQ
{
	public:
		/* Classes */
		
		class Directory : public conf::ConfString
		{
			public:
				Directory();
			protected:
				virtual bool apply(conf::Conf &conf);
		};
		
		class SaveFrequency : public conf::ConfDuration
		{
			public:
				SaveFrequency();
			protected:
				virtual bool apply_change(conf::Conf &conf);
		};
		
		/* Data */
		
		Directory directory;
		SaveFrequency save_frequency;
		
		/* Functions */ 
		
		/// Constructor.
		Directives(conf::ConfLogger &logger);
		
		/// Overrides DirectivesQ::add().
		bool add(conf::Conf &conf);
	private:
		Directives(Directives const &d);
		Directives &operator=(Directives const &right);
};

/*************************************************************************/

} /* namespace twilight */

/*************************************************************************/

#endif /* CONF_H */
