/* Tweakers paradise.
 *
 * Epona (c) 2000-2002, 2004 PegSoft
 * Contact us at epona@pegsoft.net
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 *
 * Based on the original code of Services by Andy Church.
 *
 */

#ifndef TWEAK_H
#define TWEAK_H

/*************************************************************************/

/******* General configuration *******/

/* Default configuration file name */
#define DEFAULT_CONF_FILE	"epona.conf"

/* Maximum amount of data from/to the network to buffer (bytes). */
#define NET_BUFSIZE	65536

/******* OperServ configuration *******/

/* Define this to enable OperServ's debugging commands (Services root
 * only).  These commands are undocumented; "use the source, Luke!" */
/* #define DEBUG_COMMANDS */

/******************* END OF USER-CONFIGURABLE SECTION ********************/

/* Size of input buffer (note: this is different from BUFSIZ)
 * This must be big enough to hold at least one full IRC message, or messy
 * things will happen. */
#define BUFSIZE		1024

/* Extra warning:  If you change CHANMAX, your ChanServ database will be
 * unusable. 
 */

/* Maximum length of a channel name, including the trailing null.  Any
 * channels with a length longer than (CHANMAX-1) including the leading #
 * will not be usable with ChanServ. */
#define CHANMAX		64

/* Maximum length of a nickname, including the trailing null.  This MUST be
 * at least one greater than the maximum allowable nickname length on your
 * network, or people will run into problems using Services!  The default
 * (32) works with all servers I know of. */
#define NICKMAX		32

/* Maximum length of a password */
#define PASSMAX		32

/* Maximum length of a server name */
#define SERVERMAX   64

/* Maximum length of a server description */
#define SDESCMAX    128

/* Maximum length of a username */
#define USERMAX		10

/* Maximum length of a hostname */
#define HOSTMAX 	63

/* Maximum length of a realname */
#define REALMAX		50

/**************************************************************************/

#endif	/* TWEAK_H */
